Index: src/language/stats/regression.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/regression.q,v
retrieving revision 1.38
diff -u -p -r1.38 regression.q
--- src/language/stats/regression.q	11 Nov 2006 23:10:00 -0000	1.38
+++ src/language/stats/regression.q	5 Dec 2006 06:36:53 -0000
@@ -230,7 +230,7 @@ reg_stats_coeff (pspp_linreg_cache * c)
       label = var_to_string (v);
       /* Do not overwrite the variable's name. */
       strncpy (tmp, label, MAX_STRING);
-      if (v->type == ALPHA)
+      if (var_is_alpha (v))
 	{
 	  /*
 	     Append the value associated with this coefficient.
@@ -748,12 +748,12 @@ reg_print_categorical_encoding (FILE * f
     {
       coeff = c->coeff[i];
       v = pspp_coeff_get_var (coeff, 0);
-      if (v->type == ALPHA)
+      if (var_is_alpha (v))
 	{
 	  if (!reg_inserted (v, varlist, n_vars))
 	    {
 	      fprintf (fp, "struct pspp_reg_categorical_variable %s;\n\t",
-		       v->name);
+		       var_get_name (v));
 	      varlist[n_vars] = (struct variable *) v;
 	      n_vars++;
 	    }
@@ -764,22 +764,25 @@ reg_print_categorical_encoding (FILE * f
 	   n_vars);
   for (i = 0; i < n_vars - 1; i++)
     {
-      fprintf (fp, "&%s,\n\t\t", varlist[i]->name);
+      fprintf (fp, "&%s,\n\t\t", var_get_name (varlist[i]));
     }
-  fprintf (fp, "&%s};\n\t", varlist[i]->name);
+  fprintf (fp, "&%s};\n\t", var_get_name (varlist[i]));
 
   for (i = 0; i < n_vars; i++)
     {
       coeff = c->coeff[i];
-      fprintf (fp, "%s.name = \"%s\";\n\t", varlist[i]->name,
-	       varlist[i]->name);
-      fprintf (fp, "%s.n_vals = %d;\n\t", varlist[i]->name,
+      fprintf (fp, "%s.name = \"%s\";\n\t",
+               var_get_name (varlist[i]),
+	       var_get_name (varlist[i]));
+      fprintf (fp, "%s.n_vals = %d;\n\t",
+               var_get_name (varlist[i]),
 	       varlist[i]->obs_vals->n_categories);
 
       for (j = 0; j < varlist[i]->obs_vals->n_categories; j++)
 	{
 	  val = cat_subscript_to_value ((const size_t) j, varlist[i]);
-	  fprintf (fp, "%s.values[%d] = \"%s\";\n\t", varlist[i]->name, j,
+	  fprintf (fp, "%s.values[%d] = \"%s\";\n\t",
+                   var_get_name (varlist[i]), j,
 		   value_to_string (val, varlist[i]));
 	}
     }
@@ -798,11 +801,11 @@ reg_print_depvars (FILE * fp, pspp_linre
     {
       coeff = c->coeff[i];
       v = pspp_coeff_get_var (coeff, 0);
-      fprintf (fp, "\"%s\",\n\t\t", v->name);
+      fprintf (fp, "\"%s\",\n\t\t", var_get_name (v));
     }
   coeff = c->coeff[i];
   v = pspp_coeff_get_var (coeff, 0);
-  fprintf (fp, "\"%s\"};\n\t", v->name);
+  fprintf (fp, "\"%s\"};\n\t", var_get_name (v));
 }
 static void
 reg_print_getvar (FILE * fp, pspp_linreg_cache * c)
@@ -824,10 +827,8 @@ reg_has_categorical (pspp_linreg_cache *
   for (i = 1; i < c->n_coeffs; i++)
     {
       v = pspp_coeff_get_var (c->coeff[i], 0);
-      if (v->type == ALPHA)
-	{
-	  return 1;
-	}
+      if (var_is_alpha (v))
+        return 1;
     }
   return 0;
 }
@@ -987,7 +988,7 @@ mark_missing_cases (const struct casefil
 
       val = case_data (&c, v->fv);
       cat_value_update (v, val);
-      if (mv_is_value_missing (&v->miss, val))
+      if (var_is_value_missing (v, val))
 	{
 	  if (!is_missing_case[row])
 	    {
@@ -1071,7 +1072,7 @@ prepare_data (int n_data, int is_missing
 	{
 	  indep_vars[j] = v_variables[i];
 	  j++;
-	  if (v_variables[i]->type == ALPHA)
+	  if (var_is_alpha (v_variables[i]))
 	    {
 	      /* Make a place to hold the binary vectors 
 	         corresponding to this variable's values. */
@@ -1135,7 +1136,7 @@ run_regression (const struct ccase *firs
 
   for (i = 0; i < cmd.n_dependent; i++)
     {
-      if (cmd.v_dependent[i]->type != NUMERIC)
+      if (!var_is_numeric (cmd.v_dependent[i]))
 	{
 	  msg (SE, gettext ("Dependent variable must be numeric."));
 	  pspp_reg_rc = CMD_FAILURE;
@@ -1209,12 +1210,12 @@ run_regression (const struct ccase *firs
 		   */
 		  if (!is_depvar (i, cmd.v_dependent[k]))
 		    {
-		      if (v_variables[i]->type == ALPHA)
+		      if (var_is_alpha (v_variables[i]))
 			{
 			  design_matrix_set_categorical (X, row,
 							 v_variables[i], val);
 			}
-		      else if (v_variables[i]->type == NUMERIC)
+		      else
 			{
 			  design_matrix_set_numeric (X, row, v_variables[i],
 						     val);
Index: src/language/stats/sort-criteria.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/sort-criteria.c,v
retrieving revision 1.4
diff -u -p -r1.4 sort-criteria.c
--- src/language/stats/sort-criteria.c	11 Nov 2006 23:10:00 -0000	1.4
+++ src/language/stats/sort-criteria.c	5 Dec 2006 06:36:54 -0000
@@ -116,7 +116,7 @@ sort_parse_criteria (struct lexer *lexer
         {
           struct sort_criterion *c = &criteria->crits[prev_var_cnt];
           c->fv = (*vars)[prev_var_cnt]->fv;
-          c->width = (*vars)[prev_var_cnt]->width;
+          c->width = var_get_width ((*vars)[prev_var_cnt]);
           c->dir = direction;
         }
     }
Index: src/language/stats/t-test.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/t-test.q,v
retrieving revision 1.15
diff -u -p -r1.15 t-test.q
--- src/language/stats/t-test.q	11 Nov 2006 23:10:00 -0000	1.15
+++ src/language/stats/t-test.q	5 Dec 2006 06:36:55 -0000
@@ -375,16 +375,16 @@ tts_custom_groups (struct lexer *lexer, 
       return 0;
     }
 
-  if (indep_var->type == T_STRING && indep_var->width > MAX_SHORT_STRING)
+  if (var_is_long_string (indep_var))
     {
       msg (SE, _("Long string variable %s is not valid here."),
-	   indep_var->name);
+	   var_get_name (indep_var));
       return 0;
     }
 
   if (!lex_match (lexer, '('))
     {
-      if (indep_var->type == NUMERIC)
+      if (var_is_numeric (indep_var))
 	{
 	  gp.v.g_value[0].f = 1;
 	  gp.v.g_value[1].f = 2;
@@ -403,15 +403,14 @@ tts_custom_groups (struct lexer *lexer, 
 	}
     }
 
-  if (!parse_value (lexer, &gp.v.g_value[0], indep_var->type))
+  if (!parse_value (lexer, &gp.v.g_value[0], var_get_type (indep_var)))
       return 0;
 
   lex_match (lexer, ',');
   if (lex_match (lexer, ')'))
     {
-      if (indep_var->type != NUMERIC)
+      if (var_is_alpha (indep_var))
 	{
-
 	  msg (SE, _("When applying GROUPS to a string variable, two "
 		     "values must be specified."));
 	  return 0;
@@ -423,7 +422,7 @@ tts_custom_groups (struct lexer *lexer, 
       return 1;
     }
 
-  if (!parse_value (lexer, &gp.v.g_value[1], indep_var->type))
+  if (!parse_value (lexer, &gp.v.g_value[1], var_get_type (indep_var)))
     return 0;
 
   n_group_values = 2;
@@ -702,7 +701,7 @@ ssbox_independent_samples_init(struct ss
   ssbox_base_init(this, hsize,vsize);
   tab_vline (this->t, TAL_GAP, 1, 0,vsize - 1);
   tab_title (this->t, _("Group Statistics"));
-  tab_text (this->t, 1, 0, TAB_CENTER | TAT_TITLE, indep_var->name);
+  tab_text (this->t, 1, 0, TAB_CENTER | TAT_TITLE, var_get_name (indep_var));
   tab_text (this->t, 2, 0, TAB_CENTER | TAT_TITLE, _("N"));
   tab_text (this->t, 3, 0, TAB_CENTER | TAT_TITLE, _("Mean"));
   tab_text (this->t, 4, 0, TAB_CENTER | TAT_TITLE, _("Std. Deviation"));
@@ -723,7 +722,7 @@ ssbox_independent_samples_populate(struc
 
   char prefix[2][3]={"",""};
 
-  if ( indep_var->type == NUMERIC ) 
+  if ( var_is_numeric (indep_var) ) 
     {
       val_lab0 = val_labs_find( indep_var->val_labs,gp.v.g_value[0]); 
       val_lab1 = val_labs_find( indep_var->val_labs,gp.v.g_value[1]);
@@ -755,7 +754,8 @@ ssbox_independent_samples_populate(struc
       struct hsh_table *grp_hash = group_proc_get (var)->group_hash;
       int count=0;
 
-      tab_text (ssb->t, 0, i*2+1, TAB_LEFT, cmd->v_variables[i]->name);
+      tab_text (ssb->t, 0, i*2+1, TAB_LEFT,
+                var_get_name (cmd->v_variables[i]));
 
       if (val_lab0)
 	tab_text (ssb->t, 1, i*2+1, TAB_LEFT | TAT_PRINTF, 
@@ -856,7 +856,8 @@ ssbox_paired_populate(struct ssbox *ssb,
 
 	  /* Titles */
 
-	  tab_text (ssb->t, 1, i*2+j+1, TAB_LEFT, pairs[i].v[j]->name);
+	  tab_text (ssb->t, 1, i*2+j+1, TAB_LEFT,
+                    var_get_name (pairs[i].v[j]));
 
 	  /* Values */
 	  tab_float (ssb->t,2, i*2+j+1, TAB_RIGHT, pairs[i].mean[j], 8, 2);
@@ -880,7 +881,7 @@ ssbox_one_sample_populate(struct ssbox *
     {
       struct group_statistics *gs = &group_proc_get (cmd->v_variables[i])->ugs;
 
-      tab_text (ssb->t, 0, i+1, TAB_LEFT, cmd->v_variables[i]->name);
+      tab_text (ssb->t, 0, i+1, TAB_LEFT, var_get_name (cmd->v_variables[i]));
       tab_float (ssb->t,1, i+1, TAB_RIGHT, gs->n, 2, 0);
       tab_float (ssb->t,2, i+1, TAB_RIGHT, gs->mean, 8, 2);
       tab_float (ssb->t,3, i+1, TAB_RIGHT, gs->std_dev, 8, 2);
@@ -1039,7 +1040,7 @@ trbox_independent_samples_populate(struc
       assert(gs1);
 
 	  
-      tab_text (self->t, 0, i*2+3, TAB_LEFT, cmd->v_variables[i]->name);
+      tab_text (self->t, 0, i*2+3, TAB_LEFT, var_get_name (cmd->v_variables[i]));
 
       tab_text (self->t, 1, i*2+3, TAB_LEFT, _("Equal variances assumed"));
 
@@ -1193,7 +1194,8 @@ trbox_paired_populate(struct trbox *trb,
       tab_text (trb->t, 0, i+3, TAB_LEFT | TAT_PRINTF, _("Pair %d"),i); 
 
       tab_text (trb->t, 1, i+3, TAB_LEFT | TAT_PRINTF, "%s - %s",
-		pairs[i].v[0]->name, pairs[i].v[1]->name);
+		var_get_name (pairs[i].v[0]),
+                var_get_name (pairs[i].v[1]));
 
       tab_float(trb->t, 2, i+3, TAB_RIGHT, pairs[i].mean_diff, 8, 4);
 
@@ -1287,7 +1289,7 @@ trbox_one_sample_populate(struct trbox *
       struct group_statistics *gs = &group_proc_get (cmd->v_variables[i])->ugs;
 
 
-      tab_text (trb->t, 0, i+3, TAB_LEFT, cmd->v_variables[i]->name);
+      tab_text (trb->t, 0, i+3, TAB_LEFT, var_get_name (cmd->v_variables[i]));
 
       t = (gs->mean - cmd->n_testval[0] ) * sqrt(gs->n) / gs->std_dev ;
 
@@ -1383,7 +1385,9 @@ pscbox(void)
 	       _("Pair %d"), i);
       
       tab_text(table, 1,i+1, TAB_LEFT | TAT_TITLE | TAT_PRINTF, 
-	       _("%s & %s"), pairs[i].v[0]->name, pairs[i].v[1]->name);
+	       _("%s & %s"),
+               var_get_name (pairs[i].v[0]),
+               var_get_name (pairs[i].v[1]));
 
 
       /* row data */
@@ -1653,7 +1657,7 @@ group_precalc (struct cmd_t_test *cmd )
       /* There's always 2 groups for a T - TEST */
       ttpr->n_groups = 2;
 
-      gp.indep_width = indep_var->width;
+      gp.indep_width = var_get_width (indep_var);
       
       ttpr->group_hash = hsh_create(2, 
 				    (hsh_compare_func *) compare_group_binary,
Index: src/language/utilities/set.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/utilities/set.q,v
retrieving revision 1.22
diff -u -p -r1.22 set.q
--- src/language/utilities/set.q	3 Dec 2006 22:16:46 -0000	1.22
+++ src/language/utilities/set.q	5 Dec 2006 06:36:55 -0000
@@ -774,7 +774,7 @@ show_weight (const struct dataset *ds) 
   if (var == NULL)
     msg (SN, _("WEIGHT is off."));
   else
-    msg (SN, _("WEIGHT is variable %s."), var->name);
+    msg (SN, _("WEIGHT is variable %s."), var_get_name (var));
 }
 
 static void
Index: src/language/xforms/compute.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/xforms/compute.c,v
retrieving revision 1.11
diff -u -p -r1.11 compute.c
--- src/language/xforms/compute.c	1 Dec 2006 06:51:08 -0000	1.11
+++ src/language/xforms/compute.c	5 Dec 2006 06:36:56 -0000
@@ -206,7 +206,7 @@ compute_str_vec (void *compute_, struct 
 
       vr = compute->vector->var[rindx - 1];
       expr_evaluate_str (compute->rvalue, c, case_num,
-                         case_data_rw (c, vr->fv)->s, vr->width);
+                         case_data_rw (c, vr->fv)->s, var_get_width (vr));
     }
   
   return TRNS_CONTINUE;
@@ -379,8 +379,8 @@ static int
 lvalue_get_type (const struct lvalue *lvalue) 
 {
   return (lvalue->variable != NULL
-          ? lvalue->variable->type
-          : lvalue->vector->var[0]->type);
+          ? var_get_type (lvalue->variable)
+          : var_get_type (lvalue->vector->var[0]));
 }
 
 /* Returns true if LVALUE has a vector as its target. */
@@ -401,10 +401,10 @@ lvalue_finalize (struct lvalue *lvalue, 
     {
       compute->variable = lvalue->variable;
       compute->fv = compute->variable->fv;
-      compute->width = compute->variable->width;
+      compute->width = var_get_width (compute->variable);
 
       /* Goofy behavior, but compatible: Turn off LEAVE. */
-      if (dict_class_from_id (compute->variable->name) != DC_SCRATCH)
+      if (dict_class_from_id (var_get_name (compute->variable)) != DC_SCRATCH)
         compute->variable->leave = false;
 
       /* Prevent lvalue_destroy from deleting variable. */
Index: src/language/xforms/count.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/xforms/count.c,v
retrieving revision 1.11
diff -u -p -r1.11 count.c
--- src/language/xforms/count.c	11 Nov 2006 23:10:01 -0000	1.11
+++ src/language/xforms/count.c	5 Dec 2006 06:36:56 -0000
@@ -120,7 +120,7 @@ cmd_count (struct lexer *lexer, struct d
       dv->var = dict_lookup_var (dataset_dict (ds), lex_tokid (lexer));
       if (dv->var != NULL)
         {
-          if (dv->var->type == ALPHA)
+          if (var_is_alpha (dv->var))
             {
               msg (SE, _("Destination cannot be a string variable."));
               goto fail;
@@ -149,7 +149,7 @@ cmd_count (struct lexer *lexer, struct d
 	    goto fail;
 
           crit->value_cnt = 0;
-          if (crit->vars[0]->type == NUMERIC)
+          if (var_is_numeric (crit->vars[0]))
             ok = parse_numeric_criteria (lexer, trns->pool, crit);
           else
             ok = parse_string_criteria (lexer, trns->pool, crit);
@@ -239,8 +239,8 @@ parse_string_criteria (struct lexer *lex
   size_t i;
 
   for (i = 0; i < crit->var_cnt; i++)
-    if (crit->vars[i]->width > len)
-      len = crit->vars[i]->width;
+    if (var_get_width (crit->vars[i]) > len)
+      len = var_get_width (crit->vars[i]);
 
   crit->values.str = NULL;
   for (;;)
@@ -281,7 +281,7 @@ count_numeric (struct criteria *crit, st
       if (x == SYSMIS)
         counter += crit->count_system_missing;
       else if (crit->count_user_missing
-               && mv_is_num_user_missing (&crit->vars[i]->miss, x))
+               && var_is_num_user_missing (crit->vars[i], x))
         counter++;
       else 
         {
@@ -312,7 +312,7 @@ count_string (struct criteria *crit, str
       char **v;
       for (v = crit->values.str; v < crit->values.str + crit->value_cnt; v++)
         if (!memcmp (case_str (c, crit->vars[i]->fv), *v,
-                     crit->vars[i]->width))
+                     var_get_width (crit->vars[i])))
           {
 	    counter++;
             break;
@@ -337,7 +337,7 @@ count_trns_proc (void *trns_, struct cca
 
       counter = 0;
       for (crit = dv->crit; crit; crit = crit->next)
-	if (crit->vars[0]->type == NUMERIC)
+	if (var_is_numeric (crit->vars[0]))
 	  counter += count_numeric (crit, c);
 	else
 	  counter += count_string (crit, c);
Index: src/language/xforms/recode.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/xforms/recode.c,v
retrieving revision 1.14
diff -u -p -r1.14 recode.c
--- src/language/xforms/recode.c	22 Nov 2006 04:24:03 -0000	1.14
+++ src/language/xforms/recode.c	5 Dec 2006 06:36:56 -0000
@@ -186,7 +186,7 @@ parse_src_vars (struct lexer *lexer, 
                         PV_SAME_TYPE))
     return false;
   pool_register (trns->pool, free, trns->src_vars);
-  trns->src_type = trns->src_vars[0]->type;
+  trns->src_type = var_get_type (trns->src_vars[0]);
   return true;
 }
 
@@ -202,10 +202,10 @@ parse_mappings (struct lexer *lexer, str
   size_t i;
   
   /* Find length of longest source variable. */
-  max_src_width = trns->src_vars[0]->width;
+  max_src_width = var_get_width (trns->src_vars[0]);
   for (i = 1; i < trns->var_cnt; i++) 
     {
-      size_t var_width = trns->src_vars[i]->width;
+      size_t var_width = var_get_width (trns->src_vars[i]);
       if (var_width > max_src_width)
         max_src_width = var_width;
     }
@@ -474,13 +474,13 @@ parse_dst_vars (struct lexer *lexer, str
   for (i = 0; i < trns->var_cnt; i++)
     {
       struct variable *v = trns->dst_vars[i];
-      if (v != NULL && v->type != trns->dst_type)
+      if (v != NULL && var_get_type (v) != trns->dst_type)
         {
           msg (SE, _("Type mismatch.  Cannot store %s data in "
                      "%s variable %s."),
                trns->dst_type == ALPHA ? _("string") : _("numeric"),
-               v->type == ALPHA ? _("string") : _("numeric"),
-               v->name);
+               var_is_alpha (v) ? _("string") : _("numeric"),
+               var_get_name (v));
           return false;
         }
     }
@@ -500,8 +500,8 @@ enlarge_dst_widths (struct recode_trns *
   for (i = 0; i < trns->var_cnt; i++)
     {
       struct variable *v = trns->dst_vars[i];
-      if (v->width > max_dst_width)
-        max_dst_width = v->width;
+      if (var_get_width (v) > max_dst_width)
+        max_dst_width = var_get_width (v);
     }
 
   for (i = 0; i < trns->map_cnt; i++)
@@ -530,7 +530,7 @@ create_dst_vars (struct recode_trns *trn
       *var = dict_lookup_var (dict, name);
       if (*var == NULL)
         *var = dict_create_var_assert (dict, name, 0);
-      assert ((*var)->type == trns->dst_type);
+      assert (var_get_type (*var) == trns->dst_type);
     }
 }
 
@@ -555,7 +555,7 @@ find_src_numeric (struct recode_trns *tr
           match = value == in->x.f;
           break;
         case MAP_MISSING:
-          match = mv_is_num_user_missing (&v->miss, value);
+          match = var_is_num_user_missing (v, value);
           break;
         case MAP_RANGE:
           match = value >= in->x.f && value <= in->y.f;
@@ -636,7 +636,7 @@ recode_trns_proc (void *trns_, struct cc
       if (trns->src_type == NUMERIC) 
           out = find_src_numeric (trns, src_data->f, src_var);
       else
-          out = find_src_string (trns, src_data->s, src_var->width);
+          out = find_src_string (trns, src_data->s, var_get_width (src_var));
 
       if (trns->dst_type == NUMERIC) 
         {
@@ -650,13 +650,13 @@ recode_trns_proc (void *trns_, struct cc
           if (out != NULL)
             {
               if (!out->copy_input) 
-                memcpy (dst_data->s, out->value.c, dst_var->width); 
+                memcpy (dst_data->s, out->value.c, var_get_width (dst_var)); 
               else if (trns->src_vars != trns->dst_vars)
-                buf_copy_rpad (dst_data->s, dst_var->width,
-                               src_data->s, src_var->width); 
+                buf_copy_rpad (dst_data->s, var_get_width (dst_var),
+                               src_data->s, var_get_width (src_var)); 
             }
           else if (trns->src_vars != trns->dst_vars)
-            memset (dst_data->s, ' ', dst_var->width);
+            memset (dst_data->s, ' ', var_get_width (dst_var));
         }
     }
 
Index: src/language/xforms/select-if.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/xforms/select-if.c,v
retrieving revision 1.12
diff -u -p -r1.12 select-if.c
--- src/language/xforms/select-if.c	11 Nov 2006 23:10:01 -0000	1.12
+++ src/language/xforms/select-if.c	5 Dec 2006 06:36:56 -0000
@@ -112,13 +112,13 @@ cmd_filter (struct lexer *lexer, struct 
       if (!v)
 	return CMD_FAILURE;
 
-      if (v->type == ALPHA)
+      if (var_is_alpha (v))
 	{
 	  msg (SE, _("The filter variable must be numeric."));
 	  return CMD_FAILURE;
 	}
 
-      if (dict_class_from_id (v->name) == DC_SCRATCH)
+      if (dict_class_from_id (var_get_name (v)) == DC_SCRATCH)
 	{
 	  msg (SE, _("The filter variable may not be scratch."));
 	  return CMD_FAILURE;
Index: src/math/coefficient.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/math/coefficient.c,v
retrieving revision 1.4
diff -u -p -r1.4 coefficient.c
--- src/math/coefficient.c	15 Jul 2006 20:25:01 -0000	1.4
+++ src/math/coefficient.c	5 Dec 2006 06:36:56 -0000
@@ -71,7 +71,7 @@ pspp_coeff_init (struct pspp_coeff ** c,
       c[i]->v_info->v =
 	(const struct variable *) design_matrix_col_to_var (X, i);
 
-      if (c[i]->v_info->v->type == ALPHA)
+      if (var_is_alpha (c[i]->v_info->v))
 	{
 	  size_t k;
 	  k = design_matrix_var_to_column (X, c[i]->v_info->v);
@@ -162,7 +162,7 @@ pspp_coeff_get_value (struct pspp_coeff 
     {
       return NULL;
     }
-  if (v->type == NUMERIC)
+  if (var_is_numeric (v))
     {
       return NULL;
     }
@@ -211,7 +211,7 @@ pspp_linreg_get_coeff (const pspp_linreg
     {
       return NULL;
     }
-  if (v->type == NUMERIC)
+  if (var_is_numeric (v))
     {
       return result;
     }
@@ -223,7 +223,7 @@ pspp_linreg_get_coeff (const pspp_linreg
        */
       while (tmp->index != v->index && i < c->n_coeffs
 	     && compare_values (pspp_coeff_get_value (result, tmp),
-				val, v->width))
+				val, var_get_width (v)))
 	{			/* FIX THIS */
 	  i++;
 	  result = c->coeff[i];
Index: src/math/design-matrix.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/math/design-matrix.c,v
retrieving revision 1.3
diff -u -p -r1.3 design-matrix.c
--- src/math/design-matrix.c	8 Jul 2006 03:05:52 -0000	1.3
+++ src/math/design-matrix.c	5 Dec 2006 06:36:57 -0000
@@ -115,12 +115,12 @@ design_matrix_create (int n_variables,
       (dm->vars + i)->v = v;	/* Allows us to look up the variable from
 				   the design matrix. */
       (dm->vars + i)->first_column = n_cols;
-      if (v->type == NUMERIC)
+      if (var_is_numeric (v))
 	{
 	  (dm->vars + i)->last_column = n_cols;
 	  n_cols++;
 	}
-      else if (v->type == ALPHA)
+      else if (var_is_alpha (v))
 	{
 	  assert (v->obs_vals != NULL);
 	  (dm->vars + i)->last_column =
@@ -250,7 +250,7 @@ design_matrix_set_categorical (struct de
   size_t lc;
   double entry;
 
-  assert (var->type == ALPHA);
+  assert (var_is_alpha (var));
   fc = design_matrix_var_to_column (dm, var);
   lc = dm_var_to_last_column (dm, var);
   assert (lc != DM_COLUMN_NOT_FOUND);
@@ -268,7 +268,7 @@ design_matrix_set_numeric (struct design
 {
   size_t col;
 
-  assert (var->type == NUMERIC);
+  assert (var_is_numeric (var));
   col = design_matrix_var_to_column ((const struct design_matrix *) dm, var);
   assert (col != DM_COLUMN_NOT_FOUND);
   gsl_matrix_set (dm->m, row, col, val->f);
Index: src/math/linreg/predict.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/math/linreg/predict.c,v
retrieving revision 1.10
diff -u -p -r1.10 predict.c
--- src/math/linreg/predict.c	19 May 2006 21:08:20 -0000	1.10
+++ src/math/linreg/predict.c	5 Dec 2006 06:36:57 -0000
@@ -70,7 +70,7 @@ pspp_linreg_predict (const struct variab
 	{
 	  found[i] = coe;
 	  tmp = pspp_coeff_get_est (coe);
-	  if (predictors[j]->type == NUMERIC)
+	  if (var_is_numeric (predictors[j]))
 	    {
 	      tmp *= vals[j]->f;
 	    }
Index: src/ui/gui/psppire-dict.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/ui/gui/psppire-dict.c,v
retrieving revision 1.9
diff -u -p -r1.9 psppire-dict.c
--- src/ui/gui/psppire-dict.c	17 Jul 2006 10:45:43 -0000	1.9
+++ src/ui/gui/psppire-dict.c	5 Dec 2006 06:36:57 -0000
@@ -472,8 +472,6 @@ psppire_dict_resize_variable(PsppireDict
   if ( old_size == new_size ) 
     return ;
 
-  pv->v->nv = new_size;
-
   dict_compact_values(d->dict);
 
   fv = psppire_variable_get_fv(pv);
Index: src/ui/gui/psppire-variable.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/ui/gui/psppire-variable.c,v
retrieving revision 1.7
diff -u -p -r1.7 psppire-variable.c
--- src/ui/gui/psppire-variable.c	3 Nov 2006 04:53:52 -0000	1.7
+++ src/ui/gui/psppire-variable.c	5 Dec 2006 06:36:57 -0000
@@ -43,7 +43,7 @@ psppire_variable_set_name(struct Psppire
   if ( !text) 
     return FALSE;
 
-  if ( 0 == strcmp(pv->v->name, text))
+  if ( 0 == strcmp(var_get_name (pv->v), text))
     return FALSE;
 
   if ( ! psppire_dict_check_name(pv->dict, text, TRUE) )
@@ -64,7 +64,7 @@ psppire_variable_set_columns(struct Pspp
   g_return_val_if_fail(pv->dict, FALSE);
   g_return_val_if_fail(pv->v, FALSE);
 
-  pv->v->display_width = columns;
+  var_set_display_width (pv->v, columns);
   
   psppire_dict_var_changed(pv->dict, pv->v->index);
 
@@ -78,8 +78,7 @@ psppire_variable_set_label(struct Psppir
   g_return_val_if_fail(pv->dict, FALSE);
   g_return_val_if_fail(pv->v, FALSE);
 
-  g_free(pv->v->label);
-  pv->v->label = g_strdup(label);
+  var_set_label (pv->v, label);
 
   psppire_dict_var_changed(pv->dict, pv->v->index);
 
@@ -96,8 +95,7 @@ psppire_variable_set_decimals(struct Psp
   g_return_val_if_fail(pv->dict, FALSE);
   g_return_val_if_fail(pv->v, FALSE);
 
-  fmt = pv->v->write;
-
+  fmt = *var_get_write_format (pv->v);
   fmt.d = decimals;
 
   return psppire_variable_set_format(pv, &fmt);
@@ -113,21 +111,20 @@ psppire_variable_set_width(struct Psppir
   g_return_val_if_fail(pv->dict, FALSE);
   g_return_val_if_fail(pv->v, FALSE);
 
-  fmt = pv->v->write;
-
+  fmt = *var_get_write_format (pv->v);
   fmt.w = width;
 
-  if ( pv->v->type == ALPHA ) 
+  if (var_is_alpha (pv->v))
     {
       gint old_var_cnt , new_var_cnt ;
 
-      if ( pv->v->width == 0 ) 
+      if ( var_get_width (pv->v) == 0 ) 
 	old_var_cnt = 1;
       else
-	old_var_cnt = DIV_RND_UP(pv->v->width, MAX_SHORT_STRING);
+	old_var_cnt = DIV_RND_UP(var_get_width (pv->v), MAX_SHORT_STRING);
       
       new_var_cnt = DIV_RND_UP(width, MAX_SHORT_STRING);
-    pv->v->width = width;
+      pv->v->width = width;
 
       psppire_dict_resize_variable(pv->dict, pv,
 				   old_var_cnt, new_var_cnt);
@@ -146,20 +143,20 @@ psppire_variable_set_type(struct Psppire
   g_return_val_if_fail(pv->dict, FALSE);
   g_return_val_if_fail(pv->v, FALSE);
 
-  pv->v->type = type; 
-
-  if ( pv->v->width == 0 ) 
+  if ( var_get_width (pv->v) ) 
     old_var_cnt = 1;
   else
-    old_var_cnt = DIV_RND_UP(pv->v->width, MAX_SHORT_STRING);
+    old_var_cnt = DIV_RND_UP (var_get_width (pv->v), MAX_SHORT_STRING);
 
   if ( type == NUMERIC ) 
     pv->v->width = 0;
+  else if (var_get_width (pv->v))
+    pv->v->width = 1;
 
-  if ( pv->v->width == 0 ) 
+  if ( var_get_width (pv->v) == 0 ) 
     new_var_cnt = 1;
   else
-    new_var_cnt = DIV_RND_UP(pv->v->width, MAX_SHORT_STRING);
+    new_var_cnt = DIV_RND_UP (var_get_width (pv->v), MAX_SHORT_STRING);
 
   psppire_dict_resize_variable(pv->dict, pv,
 			       old_var_cnt, new_var_cnt);
@@ -178,11 +175,11 @@ psppire_variable_set_format(struct Psppi
 
   msg_disable ();
   if ( fmt_check_output(fmt) 
-       && fmt_check_type_compat (fmt, pv->v->type)
-       && fmt_check_width_compat (fmt, pv->v->width)) 
+       && fmt_check_type_compat (fmt, var_get_type (pv->v))
+       && fmt_check_width_compat (fmt, var_get_width (pv->v))) 
     {
       msg_enable ();
-      pv->v->write = pv->v->print = *fmt;
+      var_set_both_formats (pv->v, fmt);
       psppire_dict_var_changed(pv->dict, pv->v->index);
       return TRUE;
     }
@@ -215,7 +212,7 @@ psppire_variable_set_missing(const struc
   g_return_val_if_fail(pv->dict, FALSE);
   g_return_val_if_fail(pv->v, FALSE);
 
-  mv_copy(&pv->v->miss, miss);
+  var_set_missing_values (pv->v, miss);
 
   psppire_dict_var_changed(pv->dict, pv->v->index);
   return TRUE;
@@ -227,7 +224,7 @@ psppire_variable_set_write_spec(const st
   g_return_val_if_fail(pv, FALSE);
   g_return_val_if_fail(pv->v, FALSE);
 
-  pv->v->write = fmt;
+  var_set_write_format (pv->v, &fmt);
 
   psppire_dict_var_changed(pv->dict, pv->v->index);
   return TRUE;
@@ -239,7 +236,7 @@ psppire_variable_set_print_spec(const st
   g_return_val_if_fail(pv, FALSE);
   g_return_val_if_fail(pv->v, FALSE);
 
-  pv->v->print = fmt;
+  var_set_print_format (pv->v, &fmt);
 
   psppire_dict_var_changed(pv->dict, pv->v->index);
   return TRUE;
@@ -254,7 +251,7 @@ psppire_variable_set_alignment(struct Ps
   g_return_val_if_fail(pv->dict, FALSE);
   g_return_val_if_fail(pv->v, FALSE);
 
-  pv->v->alignment = align;
+  var_set_alignment (pv->v, align);
 
   psppire_dict_var_changed(pv->dict, pv->v->index);
   return TRUE;
@@ -268,7 +265,7 @@ psppire_variable_set_measure(struct Pspp
   g_return_val_if_fail(pv->dict, FALSE);
   g_return_val_if_fail(pv->v, FALSE);
 
-  pv->v->measure = measure + 1;
+  var_set_measure (pv->v, measure + 1);
 
   psppire_dict_var_changed(pv->dict, pv->v->index);
   return TRUE;
@@ -281,8 +278,7 @@ psppire_variable_get_write_spec(const st
   g_return_val_if_fail(pv, NULL);
   g_return_val_if_fail(pv->v, NULL);
 
-
-  return &pv->v->write;
+  return var_get_write_format (pv->v);
 }
 
 
@@ -292,7 +288,7 @@ psppire_variable_get_name(const struct P
   g_return_val_if_fail(pv, NULL);
   g_return_val_if_fail(pv->v, NULL);
 
-  return pv->v->name;
+  return var_get_name (pv->v);
 }
 
 
@@ -302,7 +298,7 @@ psppire_variable_get_columns(const struc
   g_return_val_if_fail(pv, -1);
   g_return_val_if_fail(pv->v, -1);
 
-  return pv->v->display_width;
+  return var_get_display_width (pv->v);
 }
 
 
@@ -313,7 +309,7 @@ psppire_variable_get_label(const struct 
   g_return_val_if_fail(pv, NULL);
   g_return_val_if_fail(pv->v, NULL);
 
-  return pv->v->label;
+  return var_get_label (pv->v);
 }
 
 
@@ -323,7 +319,7 @@ psppire_variable_get_missing(const struc
   g_return_val_if_fail(pv, NULL);
   g_return_val_if_fail(pv->v, NULL);
 
-  return &pv->v->miss;
+  return var_get_missing_values (pv->v);
 }
 
 
@@ -343,7 +339,7 @@ psppire_variable_get_alignment(const str
   g_return_val_if_fail(pv, -1);
   g_return_val_if_fail(pv->v, -1);
 
-  return pv->v->alignment;
+  return var_get_alignment (pv->v);
 }
 
 
@@ -354,7 +350,7 @@ psppire_variable_get_measure(const struc
   g_return_val_if_fail(pv, -1);
   g_return_val_if_fail(pv->v, -1);
 
-  return pv->v->measure - 1;
+  return var_get_measure (pv->v) - 1;
 }
 
 gint
@@ -363,7 +359,7 @@ psppire_variable_get_type(const struct P
   g_return_val_if_fail(pv, -1);
   g_return_val_if_fail(pv->v, -1);
 
-  return pv->v->type;
+  return var_get_type (pv->v);
 }
 
 
@@ -373,7 +369,7 @@ psppire_variable_get_width(const struct 
   g_return_val_if_fail(pv, -1);
   g_return_val_if_fail(pv->v, -1);
 
-  return pv->v->width;
+  return var_get_width (pv->v);
 }
 
 
Index: tests/bugs/temp-freq.sh
===================================================================
RCS file: /cvsroot/pspp/pspp/tests/bugs/temp-freq.sh,v
retrieving revision 1.9
diff -u -p -r1.9 temp-freq.sh
--- tests/bugs/temp-freq.sh	27 May 2006 08:36:10 -0000	1.9
+++ tests/bugs/temp-freq.sh	5 Dec 2006 06:36:57 -0000
@@ -91,7 +91,7 @@ diff -b  -w $TEMPDIR/pspp.list - << EOF
 |SEX     |A1    |
 |X       |F8.0  |
 +--------+------+
-2.1 FREQUENCIES.  X: 
+2.1 FREQUENCIES.  X 
 +-----------+--------+---------+--------+--------+--------+
 |           |        |         |        |  Valid |   Cum  |
 |Value Label|  Value |Frequency| Percent| Percent| Percent|
